package AnnotateConfig;
use strict;
use XML::Simple;

# if you have no possibility to set the config file path from the environment,
# then you can set it here
my $default_path = '/usr/local/etc/annotate.conf';
my $self;

# Singleton
sub new
{
	unless(defined($self))
	{
		my $file = (defined($ENV{"ANNOTATE_CONF"}) ? $ENV{"ANNOTATE_CONF"} : $default_path);
		$self->{'config'} = XMLin($file);
		bless($self);

	}

	return($self);
}

sub get
{
	my $self = shift;
	my $key = shift;

	$self->{'config'}->{'xsl:variable'}->{$key}->{'content'};
}

sub set
{
	my $self = shift;
	my $key = shift;
	my $value = shift;

	$self->{'config'}->{'xsl:variable'}->{$key}->{'content'} = $value;
}

1;
