package Output::Annotate;

use Output::Hide;
@ISA = ('Output::Hide');

use strict;
use Annotations;

sub new
{
	my $self = new Output::Hide(@_);
	my $Config = new AnnotateConfig;

	$self->{'tpl'} = new HTML::Template('filename' => $Config->get('TemplateRoot') . '/' .$Config->get('AnnotateTemplate'));

	bless($self);
}

sub annotation
{
	my $self = shift;
	my $node_id = shift;
	my $content = shift;
	my $selected_node_id = shift;
	my $Config = new AnnotateConfig;

	# if the current node is the one selected for annotation, generate
	# an entry form with the current node and all annotations in it
	if($node_id eq $selected_node_id)
	{
		my $Annotations = new Annotations();
		my $annotations = $Annotations->get_annotations($node_id);
		my $tpl = new HTML::Template(
			'filename' => $Config->get('TemplateRoot') . '/' . $Config->get('ViewTemplate'),
			'die_on_bad_params' => 0
		);

		if($#$annotations >= 0)
		{
			$tpl->param('ROW' => $annotations);
			$content .= $tpl->output();
		}

		$self->{'tpl'}->param('NODE_ID' => $node_id);
		$self->{'tpl'}->param('CONTENT' => $content);
		$self->{'tpl'}->param('NAME' => $Config->get('UserName'));
		$self->{'tpl'}->param('EMAIL' => $Config->get('UserEmail'));
		return $self->{'tpl'}->output();
	}
	# otherwise just return the node's content (just as in the Hide module)
	else
	{
		return $content;
	}
}

1;
