package Output::Inline;

use Output::Hide;
@ISA = ('Output::Hide');

use strict;
use Annotations;

sub new
{
	my $self = new Output::Hide(@_);
	my $Config = new AnnotateConfig;

	$self->{'tpl'} = new HTML::Template('filename' => $Config->get('TemplateRoot') . '/' . $Config->get('LinkTemplate'));

	bless($self);
}

sub annotation
{
	my $self = shift;
	my $node_id = shift;
	my $content = shift;
	my $Config = new AnnotateConfig;
	my $tpl = new HTML::Template(
		'filename' => $Config->get('TemplateRoot') . '/' . $Config->get('ViewTemplate'), 
		'die_on_bad_params' => 0
	);

	my $Annotations = new Annotations();
	my $annotations = $Annotations->get_annotations($node_id);

	if($#$annotations >= 0)
	{
		$tpl->param('NODE_ID' => $node_id);
		$tpl->param('ROW' => $annotations);
		return $content . $tpl->output() . $self->make_links($node_id);
	}
	else
	{
		return $content . $self->make_links($node_id);
	}
}

sub make_links
{
    my $self = shift;
    my $node_id = shift;

    $self->{'tpl'}->param('ANNOTATE_URL' => "?mode=Annotate&node_id=$node_id#_annotate-form");
    return $self->{'tpl'}->output();
}

1;
