package Output::ViewAnnotations;

use Output::Hide;
@ISA = ('Output::Hide');

use strict;
use Annotations;

sub new
{
	my $self = new Output::Hide(@_);

	bless($self);
}

# show only the selected part of the document
sub tag_handler
{
	my $self = shift;
	my $event = shift;
	my $tagname = shift;
	my $attr = shift;
	my $text = shift;
	my $selected_node_id = shift;

	if($tagname eq 'annotate')
	{
		if($event eq 'start')
		{
			# an <annotate> section begins: increment depth
			# and save the node_id
			$$self{'depth'}++;
			$$self{'node_id'}[$$self{'depth'}] = $$attr{'node_id'};
			
			if($$attr{'node_id'} eq $selected_node_id)
			{
				$$self{'inside'} = 1;
			}
		}
		elsif($event eq 'end')
		{
			# an <annotate> section ends: process the contents
			# of the section using $self->annotation()
			# then append the result to the result of depth-1
			# and decrement the current depth

			if($$self{'node_id'}[$$self{'depth'}] eq $selected_node_id)
			{
				$$self{'inside'} = 0;
				$$self{'stack'}[$$self{'depth'}-1] .= $self->annotation($$self{'node_id'}[$$self{'depth'}], $$self{'stack'}[$$self{'depth'}], $selected_node_id);
			}
			undef $$self{'stack'}[$$self{'depth'}];
			$$self{'depth'}--;
		}
	}
	else
	{
		if($$self{'inside'})
		{
			$$self{'stack'}[$$self{'depth'}] .= $text;
		}
	}
}

sub annotation
{
	my $self = shift;
	my $node_id = shift;
	my $content = shift;
	my $Config = new AnnotateConfig;
	my $tpl = new HTML::Template(
		'filename' => $Config->get('TemplateRoot') . '/' . $Config->get('ViewTemplate'),
		'die_on_bad_params' => 0
	);

	my $Annotations = new Annotations();
	my $annotations = $Annotations->get_annotations($node_id);

	if($#$annotations >= 0)
	{
		$tpl->param('ROW' => $annotations);
		return $content . $tpl->output() . $self->make_links($node_id);
	}
	else
	{
		return $content . $self->make_links($node_id);
	}
}

sub make_links
{
    my $self = shift;
    my $node_id = shift;

    return "";
}

1;
