package OutputFactory;

use strict;

sub instantiate
{
	my $mode = shift;

	unless(defined($mode))
	{
		$mode = $main::Config->get('DefaultOutputMode');
	}

	unless($mode =~ /^\w+$/)
	{
		main::catch_error("invalid output mode: $mode");
	}

	my $class = "Output::$mode";

	# remove special characters
	$mode =~ s/\W+//g;
	eval "require \"Output/$mode.pm\"" or main::catch_error("cannot load module $class: $@");

	return $class->new();
}

1;
